
################################################################
################################################################
################################################################
%aa=();
%aa=(
 'D' => '10',
 'A' => '2.10',
 'V' => '-3.7',
 'L' => '-9.2',
 'I' => '-8',
 'P' => '2.1', 
 'W' => '-10',
 'F' => '-9.2',
 'M' => '-4.2',
 'G' => '5.7',
 'S' => '6.5',
 'T' => '5.2',
 'Y' => '-1.9',
 'C' => '1.4',
 'N' => '7',
 'Q' => '6',
 'K' => '5.7',
 'R' => '4.2',
 'H' => '2.1',
 'E' => '7.8',   );

#print "enter file name\n";
#chomp($file=<>);
$file="input.txt";
open(FH,$file);
open(OUT,">out_hydrophilicity.txt");
while($line=<FH>)
{
if($line=~m/>/)
{
next;
}
chomp($line);
$line=uc($line);
@arr=();
@arr=split(//,$line);
foreach $base(@arr)
{
print OUT "$aa{$base}\t";
}
print OUT "\n";
}
close(FH);
close(OUT);
################################################################
################################################################
################################################################
%aa=(
 'D' => '0.78',
 'A' => '0.49',
 'V' => '0.36',
 'L' => '0.4',
 'I' => '0.34',
 'P' => '0.75', 
 'W' => '0.51',
 'F' => '0.42',
 'M' => '0.48',
 'G' => '0.48',
 'S' => '0.65',
 'T' => '0.7',
 'Y' => '0.76',
 'C' => '0.26',
 'N' => '0.81',
 'Q' => '0.84',
 'K' => '0.97',
 'R' => '0.95',
 'H' => '0.66',
 'E' => '0.84',   );

#print "enter file name\n";
#chomp($file=<>);
$file="input.txt";
open(FH,$file);
open(OUT,">out_acceccibility.txt");
while($line=<FH>)
{
if($line=~m/>/)
{
next;
}
chomp($line);
$line=uc($line);
@arr=();
@arr=split(//,$line);
foreach $base(@arr)
{
print  OUT "$aa{$base}\t";
}
print OUT "\n";
}
close(FH);
close(OUT);

################################################################
################################################################
################################################################
$i=0;
open(FH,"out_acceccibility.txt")||die;
while($line=<FH>)
{
chomp($line);
$array[$i].="$line";
$i++;
}
close(FH);
################################################################
################################################################
################################################################

$i=0;
open(FH,"out_hydrophilicity.txt")||die;
while($line=<FH>)
{
chomp($line);
$array[$i].="$line";
$i++;
}
close(FH);
################################################################
################################################################
################################################################

open(OUT,">all_inone.txt");
foreach $val(@array)
{
print OUT "$val\n";
}
close(OUT);
################################################################
################################################################
################################################################
open(FH,"all_inone.txt")or die "an error occured: $!";
open(OUT,">tempall_inone.txt");
while($line=<FH>)
{
chomp($line);
@arr=();
$line=~s/\t\t/\t/g;
@arr=split/\t/,$line;
#pop(@arr);
#pop(@arr);
print OUT "1 ";
$i=1;
foreach $val(@arr)
{
print OUT "$i:$val ";
$i++;
}
print OUT "\n";
}
close(FH);
close(OUT);
################################################################
################################################################
################################################################

system("../machine/svm-scale -r ../machine/2_svm.txt.range tempall_inone.txt >test.scale");
system("../machine/svm-predict -b 1 test.scale ../machine/aff_rbf_top.model outputaffi>outaffi");
system("../machine/svm-margins -r 0 test.scale ../machine/aff_rbf_top.model margins>mar");

################################################################
################################################################
################################################################
@seq=();
%header=();
$file="input.txt";
$i=0;
open(FH,$file);
while($line=<FH>)
{
if($line=~m/>/)
{
$header{$i}=$line;
next;
}
push(@seq,$line);
$i++;
}
close(FH);
################################################################
################################################################
################################################################
$i=0;
open(FH,"margins");
while($line=<FH>)
{
chomp($line);
$margin{$i}=$line;
$i++;
}
close(FH);


################################################################
################################################################
################################################################

$file="input.txt";
open(OUT,">soln1.txt");
open(FH,$file);
open(PSSM,">pssm.out");
while($line=<FH>)
{
#print "\t Your Query Sequence is \t $line \t";
$efhand = $line;
chomp($line);
if($line=~m/>/)
{
print OUT $line."\n";
next;

}
$line=~s/\s//g;
@seq=();
@seq=split(//,$line);

$len=$#seq;
$len++;
if($len<=0)
{
next;
}

#print "$line\t";
score (@seq);
print PSSM "\n"; 
}
close(FH);
close(PSSM);
sub score 

{
my @seq=@_;

$len=$#seq;
$len++;
#$rand=(1/20)**$len;
$mr=0;
$l=0;
$file="../lib/pssm_mat_rel1.txt";
open(MAT,$file);
$i=0;
while($line=<MAT>)
{
chomp($line);
if($i==0)
{
@aa=();
@aa=split/\t/,$line;
$i++;
next;
}
@pssm=();
@pssm=split/\t/,$line;

for($j=0;$j<$#aa;$j++)
{

if($aa[$j] eq $seq[$l])
{
$score=$pssm[$j];

}
}
print PSSM "$score\t";
$mr=$mr+$score;
$l++;
}
close(MAT);
if($mr>=0)
{
#print " sequence @seq is \t\t $mr\n";
print OUT  "Relative Frequency for the sequence @seq is \t\t $mr\n";

}

}
################################################################
################################################################
################################################################
#sleep(2);

open(FH,"pssm.out");
open(OUT,">temppssm");
while($line=<FH>)
{
chomp($line);
@arr=();
$line=~s/\t\t/\t/g;
@arr=split/\t/,$line;
#pop(@arr);
#pop(@arr);
print OUT "-1 ";
$i=1;
foreach $val(@arr)

{
print OUT "$i:$val ";
$i++;
}
print OUT "\n";
}
close(FH);
close(OUT);
################################################################
################################################################
################################################################

#sleep(2);
system("../machine/svm-predict temppssm ../lib/pssm.model outputpssm>out_pssm");
#system("svm-margins -r 1 temppssm ../lib/pssm.model margins>mar");


################################################################
################################################################
################################################################
@seq=();
%header=();
$file="input.txt";
$i=0;
open(FH,$file);
while($line=<FH>)
{
if($line=~m/>/)
{
$header{$i}=$line;
next;
}
push(@seq,$line);
$i++;
}
close(FH);
################################################################
################################################################
################################################################
$i=0;
open(OUT,">prediction_pssm.txt");
open(FH,"outputpssm");
while($line=<FH>)
{
chomp($line);
$line=~s/\s+//g;
if(exists $header{$i})
{
print  OUT $header{$i};
}
if($line eq "1")
{
print OUT "$line\tEF\t$seq[$i]";
}
if($line eq "-1")
{
print OUT "$line\tnon-EF\t$seq[$i]";
}

$i++;
}
close(FH);
close(OUT);

################################################################
################################################################
################################################################
@pssm=();
open(FH,"pssm.out");
while($line=<FH>)
{
chomp($line);
@array=split(/\t/,$line);
$sum=0;
foreach $value(@array)
{
$sum=$sum+$value;
}
push(@pssm,$sum);
}
close(FH);
################################################################
################################################################
################################################################
$i=0;
open(OUT,">prediction_affinity.txt")or die "an error occured: $!";
open(FH,"margins");
$flag=1;
while($line=<FH>)
{
chomp($line);
$line=~s/\s+//g;
if(exists $header{$i})
{
if($flag==0)
{
print OUT "No hit found\n";
}
$flag=0;
$header=$header{$i};
$header=~s/>//;
print  OUT $header;
}
if($line >=  0.1)
{
$flag++;
chomp($seq[$i]);
print OUT "High Affinity Site \t$seq[$i]\t\tSVM Score = $margin{$i}\tPSSM Score is \t\t $pssm[$i]\n";
}

if($line <= 0.09 && $line  >= -2.10)
{
chomp($seq[$i]);
$flag++;
print OUT "Low Affinity Site \t$seq[$i]\t\tSVM Score = $margin{$i}\t PSSM Score is \t\t $pssm[$i]\n";
}

if($line <= -2.10)
{
chomp($seq[$i]);

print OUT "Non Binding SITE\t$seq[$i]\t\tSVM Score = $margin{$i}\t PSSM Score is \t\t $pssm[$i]\n";
}



chomp($line);
$i++;

#print OUT "\n";
}

if($flag==0)
{
print OUT "No Hit found\n";
}
close(FH);
close(OUT);
################################################################
################################################################
################################################################

